// A C++ Game to play Battleships with Computer
#include<direct.h>
#include<iostream>
#include <cstdlib>
#include<time.h>
#include <stdio.h>
#include <stdlib.h>
#include "libs/rlutil.h"

#include <istream>

#include <fstream>
#include <iterator>
#include <ctime>


using namespace std;

#define MAX_NUM 10

inline void mySleep(clock_t sec) // clock_t is a like typedef unsigned int clock_t. Use clock_t instead of integer in this context
{
clock_t start_time = clock();
clock_t end_time = sec * 1000 + start_time;
while(clock() != end_time);
}




//change matrix  !!!!!!
void mazegeneraterplayer(int a[10][10])
{
    //generating a maze filled with 4 ships of size 3


    a[1][1]=1;
    a[1][2]=1;
    a[1][3]=1;

    a[8][6]=1;
    a[8][8]=1;
    a[8][7]=1;

    a[8][1]=1;
    a[8][2]=1;
    a[8][3]=1;

    a[2][8]=1;
    a[2][6]=1;
    a[2][7]=1;





}

void mazegeneratercomputer(int a[10][10])
{
    //generating a maze filled with 4 ships of size 3


    a[3][1]=1;
    a[5][1]=1;
    a[4][1]=1;

    a[2][4]=1;
    a[3][4]=1;
    a[4][4]=1;

    a[6][2]=1;
    a[6][4]=1;
    a[6][3]=1;


    a[5][6]=1;
    a[6][6]=1;
    a[4][6]=1;





}

void display (int a[10][10],int h[10][10])
{   rlutil::setColor(11);
            cout<<"\n\n             Players Maze                  Hits         ";

            cout<<"\n\n            0 1 2 3 4 5 6 7 8 9         0 1 2 3 4 5 6 7 8 9";
    for(int i=0;i<10;i++)
        {
            rlutil::setColor(7);
            cout<<"\n\n           _____________________      _____________________";
            cout<<"\n        ";
            rlutil::setColor(11);
            cout<<i<<"  ";
            for(int j=0;j<10;j++)

            {

                rlutil::setColor(7);
                cout<<"|";


                        rlutil::setColor(14);
                        if(a[i][j]==1)cout <<"P";



                    if(a[i][j]==0)
                        {
                            rlutil::setColor(7);
                            cout<<" ";
                        }

            }

            rlutil::setColor(7);
            cout<<"|   ";
            rlutil::setColor(11);
            cout<<i<<"  ";

            for(int j=0;j<10;j++)
            {   rlutil::setColor(7);
                cout<<"|";

                 if(h[i][j]!=0)
                {
                    rlutil::setColor(7);

                    rlutil::setColor(9);
                     if(h[i][j]==1)cout<<"o";

                        if(h[i][j]==4)
                            {
                                rlutil::setColor(12);
                                 cout<<"c";
                                }
                        if(h[i][j]==5)
                            {

                                rlutil::setColor(14);
                                cout <<"p";


                            }



                }else
                    {
                        rlutil::setColor(7);
                        cout<<" ";

                    }


            }
            cout<<"|";



        }





}

//display for multiplayer   matm hitm

void displaym(int a[10][10],int h[10][10],int idm)
{   rlutil::setColor(11);
            cout<<"\n\n             Players Maze                     Hits         ";

            cout<<"\n\n            0 1 2 3 4 5 6 7 8 9         0 1 2 3 4 5 6 7 8 9";
    for(int i=0;i<10;i++)
        {
            rlutil::setColor(7);

            cout<<"\n\n           _____________________      _____________________";
            cout<<"\n        ";
            rlutil::setColor(11);
            cout<<i<<"  ";
            for(int j=0;j<10;j++)

            {

                rlutil::setColor(7);
                cout<<"|";


                        rlutil::setColor(14);
                        if(a[i][j]==idm)cout <<idm;
                        else

                        {
                            rlutil::setColor(7);
                            cout<<" ";
                        }

            }

            rlutil::setColor(7);
            cout<<"|   ";
            rlutil::setColor(11);
            cout<<i<<"  ";

            for(int j=0;j<10;j++)
            {   rlutil::setColor(7);
                cout<<"|";

                 if(h[i][j]!=0)
                {


                    rlutil::setColor(12);
                    if(h[i][j]==9)cout<<'x';
                    rlutil::setColor(14);
                     if(h[i][j]!=0&&h[i][j]!=9)cout<<h[i][j];


                }
                else
                    {
                        rlutil::setColor(7);
                        cout<<" ";

                    }


            }
            cout<<"|";



        }





}



// to check finish

int checkend(int h[10][10])
{
    int a1=0,b1=0;
    for(int i=0;i<9;i++)
        {
            for(int j=0;j<9;j++)
                {
                    if(h[i][j]==4)a1++;
                    if(h[i][j]==5)b1++;

                }


        }

    if (a1==12)
        return 2;
    else
        if (b1==12)
        return 3;
    else
        return 0;           // continue with game






}


int checkendm(int h[10][10],int lop)
{
    int * th=new int[lop];
    for(int i=0;i<lop;i++)
        th[i]=0;
    for(int i=0;i<9;i++)
        {
            for(int j=0;j<9;j++)
                {
                    for(int koo=0;koo<lop;koo++)
                        if(h[i][j]==koo)th[koo]++;


                }


        }

    for(int i=0;i<lop;i++)
        {
            if(th[i]==3)return i;

        }

        return 0;           // continue with game






}
    //(computer,hit,xy,h,l,r);

int compchance(int b[10][10],int h[10][10],int xy[10][10],int nexthit[2],int l[2],int r)
{
    int x=0,y=0;
    // xy [][] = x,y,(which  direction)   we will go clockwise for checking
    // xy [][] = 4  mean no need to check

    // l : last hit   where g is the index

    // xy to specify direction of last step

    // r used to say whether or not to randomize
   int p;

    if(r==1)
    {
        randm:

           srand ( time(NULL) );
           nexthit[0] = (rand() %8) +1 ;
           nexthit[1] = (rand() %8) +1 ;

           if((h[nexthit[0]][nexthit[1]]==0)&&b[nexthit[0]][nexthit[1]]!=1)
                return 0;

           else
                goto randm;

    }

     if(r==0)
     {

         //for direction = 0

         d0:

            if(xy[l[0]][l[1]]==0)
                {
                    if(h[l[0]+1][l[1]]==5&&h[l[0]+2][l[1]]==5)
                        {
                            xy[l[0]][l[1]]=4;
                            xy[l[0]+1][l[1]]=4;
                            xy[l[0]+2][l[1]]=4;

                            goto randm;

                        }


                   else  if(h[l[0]+1][l[1]]==5)
                        {
                            if(h[l[0]-1][l[1]]==1)
                                {
                                    l[0]=l[0]+1;                //reseting it to original hit
                                    xy[l[0]][l[1]]=2;
                                    goto d2;
                                }
                            else
                            {
                                nexthit[0]=l[0]-1;
                                nexthit[1]=l[1];
                            }

                        }


                   else

                        if(h[l[0]-1][l[1]]==1)
                             {xy[l[0]][l[1]]=1;
                             goto d1;}

                         else

                            {
                                nexthit[0]=l[0]-1;
                                nexthit[1]=l[1];
                            }





                }


        // for direction = 1

        d1:

                if(xy[l[0]][l[1]]==1)
                {
                    if(h[l[0]][l[1]-1]==5&&h[l[0]][l[1]-2]==5)
                        {

                            xy[l[0]][l[1]]=4;
                            xy[l[0]][l[1]-1]=4;
                            xy[l[0]][l[1]-2]=4;

                            goto randm;

                        }


                   else  if(h[l[0]][l[1]-1]==5)
                        {
                            if(h[l[0]][l[1]+1]==1)
                                {
                                    l[1]=l[1]-1;                //reseting it to original hit
                                    xy[l[0]][l[1]]=3;
                                    goto d3;
                                }
                            else
                            {
                                nexthit[0]=l[0];
                                nexthit[1]=l[1]+1;
                            }

                        }


                   else

                        if(h[l[0]][l[1]+1]==1)
                            {

                             xy[l[0]][l[1]]=2;
                             goto d2;}

                         else

                            {
                                nexthit[0]=l[0];
                                nexthit[1]=l[1]+1;
                            }





                }




            //for direction = 2

         d2:

            if(xy[l[0]][l[1]]==2)
                {
                    if(h[l[0]-1][l[1]]==5&&h[l[0]-2][l[1]]==5)
                        {
                            xy[l[0]][l[1]]=4;
                            xy[l[0]-1][l[1]]=4;
                            xy[l[0]-2][l[1]]=4;

                            goto randm;

                        }


                   else  if(h[l[0]-1][l[1]]==5)
                        {
                            if(h[l[0]+1][l[1]]==1)
                                {
                                    l[0]=l[0]-1;                //reseting it to original hit
                                    xy[l[0]][l[1]]=0;
                                    goto d0;
                                }
                            else
                            {
                                nexthit[0]=l[0]+1;
                                nexthit[1]=l[1];
                            }

                        }


                   else

                        if(h[l[0]+1][l[1]]==1)
                             {xy[l[0]][l[1]]=3;
                             goto d3;}

                         else

                            {
                                nexthit[0]=l[0]+1;
                                nexthit[1]=l[1];
                            }





                }



                     // for direction = 3

        d3:

                if(xy[l[0]][l[1]]==3)
                {
                    if(h[l[0]][l[1]+1]==5&&h[l[0]][l[1]+2]==5)
                        {
                            xy[l[0]][l[1]]=4;
                            xy[l[0]][l[1]+1]=4;
                            xy[l[0]][l[1]+2]=4;

                            goto randm;

                        }


                   else  if(h[l[0]][l[1]+1]==5)
                        {
                            if(h[l[0]][l[1]-1]==1)
                                {
                                    l[1]=l[1]+1;                //reseting it to original hit
                                    xy[l[0]][l[1]]=1;
                                    goto d1;
                                }
                            else
                            {
                                nexthit[0]=l[0];
                                nexthit[1]=l[1]-1;
                            }

                        }


                   else

                        if(h[l[0]][l[1]-1]==1)
                             goto randm;

                         else

                            {
                                nexthit[0]=l[0];
                                nexthit[1]=l[1]-1;
                            }





                }








     }




}


int main()
{
    int player[10][10]={0};          // showing player's ships
    int computer[10][10]={0};        // showing computer's ships
    int hit[10][10]={0};             // showing hits on ships
    int xy[10][10]={0};              // to get the last direction in a cell
    int l[2]={0,0};                    // to pass the last location
    int h[2]={0};                    // to get the next hit position
    int r=1;                         // tells to randomize or not
    char q;
    int x=0,y=0;
    int finish=0;               //  used for checking whether the game has ended

    //generating maze
    mazegeneraterplayer(player);
    mazegeneratercomputer(computer);



    //the welcoming and instruction
    rlutil::setColor(12);
    cout<<"\n\n\n\t\t\t         Battle Ships !";
    rlutil::setColor(14);
    cout<<"\n\n\n    This program will help you to play a well known game the Battleships, ";
    cout<<"\n    The basic aim of the game is to kill all the opponents ships before he ";
    cout<<"\n    kills your's. The players play chance by chance, to make the game more ";
    cout<<"\n    interesting none of them know where the opponent's ship is so they have";
    cout<<"\n    to guess where the other players ship could be and start hitting ";
    rlutil::setColor(12);

    cout<<"\n\n\n    The main things to remember are   : ";
    cout<<"\n\n    1.  There are 4 ships for each player each of size = 3 ";
    cout<<"\n";
    cout<<"\n\t  ___|____|____";
    cout<<"\n\t  _P_|__P_|__P_";
    cout<<"\n\t  ___|____|____";
    cout<<"\n\t     |    |";
    cout<<"\n\n    2.  The ships are placed on a 10X10 matrix ";
    cout<<"\n\n    3.  The ships are placed horizontally or vertically ";
    cout<<"\n";
    cout<<"\n\t  ___|____|____          ___|_P__|____  ";
    cout<<"\n\t  _P_|__P_|__P_          ___|_P__|____  ";
    cout<<"\n\t  ___|____|____          ___|_P__|____  ";
    cout<<"\n\t     |    |                 |    |    ";
    cout<<"\n\n    4.  The bombs have to be placed using co-ordinates like 0 0 ";
    cout<<"\n\n    5.  Once a player hits the opponents ship or misses it a color coded ";
    cout<<"\n        symbol is used to denote it";
    cout<<"\n\n    6.  After the player's turn the computer will hit a block and it ";
    cout<<"\n        shown in Hit maze ";
    cout<<"\n\n    7.  While gameplay you can view these instructions again by pressing 10 10\n        and quit if required ";
    cout<<"\n\n    8.  The Ships dont move  ";
    cout<<"\n\n    9.  Make the terminal screen fullscreen for better viewing experience.   ";
dd:
    rlutil::setColor(15);

    cout<<"\n\n\n        Do you want to continue and play  (Y/N) :  ";
    cin>>q;
rlutil::setColor(3);
    if(q=='Y'||q=='y'){}

    else if(q=='n'||q=='N') {
            rlutil::setColor(14);
        cout<<"\n\n\t It was a pleasure having You play our game, Hoping to see you soon !!\n\t (enter y to exit)";
        cin>>q;

        if(q=='Y'||q=='y')
        exit(0);

    }
    else goto dd;

    rlutil::setColor(15);
system("cls");                //  refreshing screen
    cout<<"\n\n\n    The color codes are as follows  : ";
    cout<<"\n\n    For Player Maze :\n";

    cout<<"\n    1.  The ships of player :   ";
    rlutil::setColor(14);
    cout<<"P";
    rlutil::setColor(15);
    cout<<"\n\n    For Hit Maze :\n";
    rlutil::setColor(15);
    cout<<"\n    2.  The places where bomb was placed but nothing was there :   ";
    rlutil::setColor(9);
    cout<<"o";
    rlutil::setColor(15);
    cout<<"\n    3.  The destroyed ships of computer :   ";
    rlutil::setColor(12);
    cout<<"c";
    rlutil::setColor(15);
    cout<<"\n    4.  The destroyed ships of player :   ";
    rlutil::setColor(14);
    cout <<"p";
    rlutil::setColor(15);



cout<<"\n\n\n        Do you want to continue and play  (Y/N) :  ";
    cin>>q;
rlutil::setColor(3);
    if(q=='Y'||q=='y'){}

    else {
            rlutil::setColor(14);
        cout<<"\n\n\t It was a pleasure having You play our game, Hoping to see you soon !!\n\t (enter y to exit)";
        cin>>q;

        if(q!='Y'&&q!='y'){}
        else
        exit(0);


    }
rlutil::setColor(12);
    system("cls");
    cout<<"\n\n\t Select a mode to play : \n\n";
    cout<<"\t 1. Single Player Mode \n\t 2. Multiplayer Mode\n\n\n\t Enter your choice ( eg: 1 )  : ";
    int f;
    abab:
    cin>>f;

    if(f==1)goto play;
    else if (f==2)goto multiplayer;
    else {cout<<"\n    Enter a valid option. ";goto abab;}

    play:
    while (finish ==0)
        {
            do
            {

                system("cls");                //  refreshing screen
                cout<<"\n\n\n\n\n";
                display (player,hit);
                ff:
                rlutil::setColor(15);

                cout<<" \n\n\n\n\n\n\n     Please, Enter your choice of co-ordinates for bombing  :  ";
                cin>>x>>y;
                //checking or validating
                if(!(x==10&&y==10)&&!(x>=0&&x<=9&&y<=9&&y>=0&&hit[x][y]==0&&player[x][y]!=1))
              {
                  cout<<"\n\n\t You Have entered wrong or invalid co-ordinates \n\t (press 10 10 on next input for help )";
                  goto ff;

              }
                if(x>=0&&x<=9&&y<=9&&y>=0&&hit[x][y]==0&&player[x][y]!=1)
                    {
                        //  Don't change player or computer when bombing only hit array
                        //  hit =0 : no hit
                        //      =1 : hit but no kill
                        //      =4 : computer died
                        //      =5 : player died



                        //  in main array
                        //                =1 : ship present
                        //                =0 : nothing

                        hit[x][y]=1;

                        if(computer[x][y]==1)
                            {
                                hit[x][y]=4;
                            }


                         if(player[x][y]==1)
                            {
                                hit[x][y]=5;
                            }


                        int a=compchance(computer,hit,xy,h,l,r);              //  asking computer to play

                        if(player[h[0]][h[1]]==1)
                        {


                            if(xy[l[0]][l[1]]!=4)
                            xy[h[0]][h[1]]=xy[l[0]][l[1]];                  // saving direction to next hit


                            hit[h[0]][h[1]]=5;
                            r=0;

                            l[0]=h[0];
                            l[1]=h[1];

                        }
                        else
                            {

                                hit[h[0]][h[1]]=1;

                                if(xy[l[0]][l[1]]==4||(hit[h[0]][h[1]]==1&&l[0]==0&&l[1]==0))
                                        r=1;
                            }

              }



              if(x==10&&y==10)
              {

    system("cls");         //  refreshing screen
rlutil::setColor(12);

    cout<<"\n\n\n    The main things to remember are   : ";
    cout<<"\n\n    1.  There are 4 ships for each player each of size = 3 ";
    cout<<"\n";
    cout<<"\n\t  ___|____|____";
    cout<<"\n\t  _P_|__P_|__P_";
    cout<<"\n\t  ___|____|____";
    cout<<"\n\t     |    |";
    cout<<"\n\n    2.  The ships are placed on a 10X10 matrix ";
    cout<<"\n\n    3.  The ships are placed horizontally or vertically ";
    cout<<"\n";
    cout<<"\n\t  ___|____|____          ___|_P__|____  ";
    cout<<"\n\t  _P_|__P_|__P_          ___|_P__|____  ";
    cout<<"\n\t  ___|____|____          ___|_P__|____  ";
    cout<<"\n\t     |    |                 |    |    ";
    cout<<"\n\n    4.  The bombs have to be placed using co-ordinates like 0 0 ";
    cout<<"\n\n    5.  Once a player hits the opponents ship or misses it a color coded ";
    cout<<"\n        symbol is used to denote it";
    cout<<"\n\n    6.  After the player's turn the computer will hit a block and it ";
    cout<<"\n        shown in Hit maze ";
    cout<<"\n\n    7.  While gameplay you can view these instructions again by pressing 10 10\n        and quit if required ";
    cout<<"\n\n    8.  The Ships dont move  ";
    cout<<"\n\n    9.  Make the terminal screen fullscreen for better viewing experience.   ";

rlutil::setColor(7);

 rlutil::setColor(15);

    cout<<"\n\n\n    The color codes are as follows  : ";
    cout<<"\n\n    For Player Maze :\n";

    cout<<"\n    1.  The ships of player :   ";
    rlutil::setColor(14);
    cout<<"P";
    rlutil::setColor(15);
    cout<<"\n\n    For Hit Maze :\n";
    rlutil::setColor(15);
    cout<<"\n    2.  The places where bomb was placed but nothing was there :   ";
    rlutil::setColor(9);
    cout<<"o";
    rlutil::setColor(15);
    cout<<"\n    3.  The destroyed ships of computer :   ";
    rlutil::setColor(12);
    cout<<"c";
    rlutil::setColor(15);
    cout<<"\n    4.  The destroyed ships of player :   ";
    rlutil::setColor(14);
    cout <<"p";
    rlutil::setColor(15);




cout<<"\n\n\n        Do you want to continue and play  (Y/N) :  ";
    cin>>q;
rlutil::setColor(3);
    if(q=='Y'||q=='y'){goto play;}

    else {
            rlutil::setColor(14);
        cout<<"\n\n\t It was a pleasure having You play our game, Hoping to see you soon !!\n\t (enter y to exit)";
        cin>>q;

        if(q!='Y'&&q!='y'){}
        else
        exit(0);


    }

              }


            }while (!(x>=0&&x<=9&&y<=9&&y>=0));


        finish=checkend(hit);
        //y
//if(finish!=0)
        //display (player,hit);

        }

        rlutil::setColor(14);
     cout<<"\n\n\n\t\tGAME OVER  !!!   ";
     if(finish==2)cout<<"Player won";
     if(finish==3)cout<<"Computer won";
     cout<<"\n\n\n";

multiplayer:
     if(f==2)
     {
         rlutil::setColor(12);
         system("cls");

         cout<<"\n\n\t  Enter The number of players  playing  ( eg : 3 ) :  ";
         int p;             //untouched Number of players
         cin>>p;
         int h=p;
         FILE * fu=fopen("username.txt","r+");
         fclose(fu);                                            //refresh username.txt

         const int lop=p;
         FILE * pp=fopen("lop.txt","r+");
         fprintf(pp,"%d",p);
         fclose(pp);
         FILE * f=fopen("username.txt","r+");
         fseek(f,0,SEEK_SET);
         while(h>0)                                                 //saving players name and make copies client.cpp
         {
             cout<<"\n\t  Enter the name of player  "<<p-h+1<<"  :  ";
             string username1;
             cin>>username1;
             char as,ad,af;
             as=username1[0];
             ad=username1[1];
             af=username1[2];
             fprintf(f,"%c%c%c",as,ad,af);
             --h;
             char name[44]="C:/Users/franklin/Documents/Battle ship/";

             name[40]=username1[0];
             name[41]=username1[1];
             name[42]=username1[2];
            // mkdir(name);
             char play[54]="C:/Users/franklin/Documents/Battle ship/";
             play[40]=username1[0];
             play[41]=username1[1];
             play[42]=username1[2];

             play[43]='.';
             play[44]='c';
             play[45]='p';
             play[46]='p';



             fstream f("C:/Users/franklin/Documents/Battle ship/client.cpp", fstream::in|fstream::binary);        //creating a copy of client.cpp
              f << noskipws;
              istream_iterator<unsigned char> begin(f);
              istream_iterator<unsigned char> end;

              fstream f2(play,
                fstream::out|fstream::trunc|fstream::binary);
              ostream_iterator<char> begin2(f2);

              copy(begin, end, begin2);



         }
        char nam[3];
        string kik;

        wrongid:

        cout<<"\n\n  \t  Whats your name ?  :";
        cin>>kik;
        nam[0]=kik[0];
        nam[1]=kik[1];
        nam[2]=kik[2];

         h=lop;
        int idm=0;
        char r,e,g;

        fseek(f,0,SEEK_SET);
         while(h>0)
            {
                idm++;
                fscanf(f,"%c%c%c",&r,&e,&g);

                if(r==nam[0]&&e==nam[1]&&g==nam[2])
                    break;
                h--;
            }

            if(h==0){cout<<"\n\n\t Wrong iD entered , Enter again :  ";goto wrongid;}





        system ("cls");
        cout<<"\n\n\t The Order of Rank is :  \n\n";                // Showing Rank
        fseek(f,0,SEEK_SET);
        int u=0;
        p=lop;
        h=p;

        while(h>0)                                          // Showing Rank
            {

                u++;
                fscanf(f,"%c%c%c",&r,&e,&g);
                cout<<"\n\t "<<p-h+1<<".  "<<r<<e<<g<<"\n";



                h--;
            }                                           //finished making rank txt available and showing rank
cout<<"\n\n\t Press enter to continue ......";
getch();

int hitm[10][10],matm[10][10];                               //multiplayer versions of hit and mat
system("cls");

//finding iD




                        FILE * fhit=fopen("hit.txt","r+");
                        FILE * fmat=fopen("mat.txt","r+");



                        for(int hi=0;hi<10;hi++)
                {
                    for(int hj=0;hj<10;hj++)
                    {
                        hitm[hi][hj]=0;
                        matm[hi][hj]=0;
                        fprintf(fhit,"%d",hitm[hi][hj]);
                        fprintf(fmat,"%d",matm[hi][hj]);




                    }
                }

                fclose(fhit);
                fclose(fmat);



FILE * fe=fopen("chance.txt","r+");
fclose(fe);                                            //refresh chance.txt




         FILE * fmt=fopen("mat.txt","r");

                fseek(fmt,0,SEEK_SET);
                for(int hi=0;hi<10;hi++)
                {
                    for(int hj=0;hj<10;hj++)
                    {
                        char jk;

                        fscanf(fmt,"%c",&jk);
                        matm[hi][hj]=int(jk)-48;




                    }
                }
                fclose(fmt);

system("cls");
cout<<"\n\n    Enter the co-ordinates where  you want to \n    place ships ( 3 ships of size 1 each )  :   ";

int hu=0,k=0;
for(int ppp=0;ppp<3;ppp++)
{
    int ik=0;
    assk:
    cin>>hu>>k;

    if(matm[hu][k]==0)matm[hu][k]=idm;
    else{cout<<"\n\t Enter another co-ordinates  :  ";goto assk ;}



}


                FILE * fma=fopen("mat.txt","w+");

                fseek(fma,0,SEEK_SET);
                for(int hi=0;hi<10;hi++)
                {
                    for(int hj=0;hj<10;hj++)
                    {
                        char jk;

                            jk=matm[hi][hj]+48;
                            fprintf(fma,"%c",jk);

                    }
                }
                fclose(fma);




            //ask users to place ship   *****



        playm:
                //check for end
                //check for chance
                //give input
                //make changes to chance.txt
                finish=0;
                //reading hit and mat
                fhit=fopen("hit.txt","r");
                fmat=fopen("mat.txt","r");
                fseek(fhit,0,SEEK_SET);
                fseek(fmat,0,SEEK_SET);

                for(int hi=0;hi<10;hi++)
                {
                    for(int hj=0;hj<10;hj++)
                    {
                        char jk;
                        fscanf(fhit,"%c",&jk);
                        hitm[hi][hj]=int(jk)-48;

                        fscanf(fmat,"%c",&jk);
                        matm[hi][hj]=int(jk)-48;




                    }
                }

                //  staring the game

        while(finish==0){

             do{
                 FILE * fhit=fopen("hit.txt","r");
                FILE * fmat=fopen("mat.txt","r");
                fseek(fhit,0,SEEK_SET);
                fseek(fmat,0,SEEK_SET);
                for(int hi=0;hi<10;hi++)
                {
                    for(int hj=0;hj<10;hj++)
                    {
                        char jk;
                        fscanf(fhit,"%c",&jk);
                        hitm[hi][hj]=int(jk)-48;

                        fscanf(fmat,"%c",&jk);
                        matm[hi][hj]=int(jk)-48;




                    }
                }
                fclose(fhit);
                        fclose(fmat);

                system("cls");                //  refreshing screen
                cout<<"\n\n\n\n\n";
                displaym (matm,hitm,idm);
                wrngco:
                rlutil::setColor(15);

                cout<<" \n\n\n\n\n\n\n     Please, Enter your choice of co-ordinates for bombing  :  ";

                cin>>x>>y;
                //checking or validating
                if(!(x==10&&y==10)&&!(x>=0&&x<=9&&y<=9&&y>=0&&matm[x][y]!=idm))
              {
                  cout<<"\n\n\t You Have entered wrong or invalid co-ordinates \n\t (press 10 10 on next input for help )";
                  goto wrngco;

              }
                if(x>=0&&x<=9&&y<=9&&y>=0&&hitm[x][y]==0&&matm[x][y]!=idm)
                    {
                        //  Don't change player or computer when bombing only hit array
                        //  hit =0 : no hit
                        //      =1 : hit but no kill




                        hitm[x][y]=9;

                        if(matm[x][y]!=0)
                            {
                                for(int pol=1;pol<=lop;pol++)
                                if(matm[x][y]==pol)
                                hitm[x][y]=pol;
                            }
                        //giving others to play

                        /*  1.updating hitm and matm with file
                            2.deciding who is next
                            3.waiting for ur chance
                            4.then repeating
                        */
                        fclose(fhit);
                        fclose(fmat);

                        FILE * fhit=fopen("hit.txt","r+");
                        FILE * fmat=fopen("mat.txt","r+");



                        for(int hi=0;hi<10;hi++)
                {
                    for(int hj=0;hj<10;hj++)
                    {
                        fprintf(fhit,"%d",hitm[hi][hj]);
                        fprintf(fmat,"%d",matm[hi][hj]);




                    }
                }

                fclose(fhit);
                fclose(fmat);
                                                        //updated mat and hit

                //deciding who is next

                FILE * fchance=fopen("chance.txt","r+");

                int kikik=idm+1;
                if((idm)==lop)kikik=1;

                fprintf(fchance,"%d",kikik);



                fclose(fchance);
                int mychance=0;




                system("cls");
                displaym(matm,hitm,idm);
                cout<<"\n\n\t Waiting For others to play...............";

                while(mychance!=1)
                {
                    cout<<"";
                    int hkh;
                    FILE * fchance=fopen("chance.txt","r");

                    fseek(fchance,0,SEEK_SET);
                    fscanf(fchance,"%d",&hkh);
                    fclose(fchance);

                    if(hkh==idm)
                        mychance=1;
                        else
                    getch();
                }                           //  chance is transferred to me















              }



              if(x==10&&y==10)
              {

    system("cls");         //  refreshing screen
rlutil::setColor(12);

    cout<<"\n\n\n    The main things to remember are   : ";
    cout<<"\n\n    1.  There are 4 ships for each player each of size = 3 ";
    cout<<"\n";
    cout<<"\n\t  ___|____|____";
    cout<<"\n\t  _P_|__P_|__P_";
    cout<<"\n\t  ___|____|____";
    cout<<"\n\t     |    |";
    cout<<"\n\n    2.  The ships are placed on a 10X10 matrix ";
    cout<<"\n\n    3.  The ships are placed horizontally or vertically ";
    cout<<"\n";
    cout<<"\n\t  ___|____|____          ___|_P__|____  ";
    cout<<"\n\t  _P_|__P_|__P_          ___|_P__|____  ";
    cout<<"\n\t  ___|____|____          ___|_P__|____  ";
    cout<<"\n\t     |    |                 |    |    ";
    cout<<"\n\n    4.  The bombs have to be placed using co-ordinates like 0 0 ";
    cout<<"\n\n    5.  Once a player hits the opponents ship or misses it a color coded ";
    cout<<"\n        symbol is used to denote it";
    cout<<"\n\n    6.  After the player's turn the computer will hit a block and it ";
    cout<<"\n        shown in Hit maze ";
    cout<<"\n\n    7.  While gameplay you can view these instructions again by pressing 10 10\n        and quit if required ";
    cout<<"\n\n    8.  The Ships dont move  ";
    cout<<"\n\n    9.  Make the terminal screen fullscreen for better viewing experience.   ";

rlutil::setColor(7);

 rlutil::setColor(15);

    cout<<"\n\n\n    The color codes are as follows  : ";
    cout<<"\n\n    For Player Maze :\n";

    cout<<"\n    1.  The ships of player :   ";
    rlutil::setColor(14);
    cout<<"P";
    rlutil::setColor(15);
    cout<<"\n\n    For Hit Maze :\n";
    rlutil::setColor(15);
    cout<<"\n    2.  The places where bomb was placed but nothing was there :   ";
    rlutil::setColor(9);
    cout<<"o";
    rlutil::setColor(15);
    cout<<"\n    3.  The destroyed ships of computer :   ";
    rlutil::setColor(12);
    cout<<"c";
    rlutil::setColor(15);
    cout<<"\n    4.  The destroyed ships of player :   ";
    rlutil::setColor(14);
    cout <<"p";
    rlutil::setColor(15);




cout<<"\n\n\n        Do you want to continue and play  (Y/N) :  ";
    cin>>q;
rlutil::setColor(3);
    if(q=='Y'||q=='y'){goto playm;}

    else {
            rlutil::setColor(14);
        cout<<"\n\n\t It was a pleasure having You play our game, Hoping to see you soon !!\n\t (enter y to exit)";
        cin>>q;

        if(q!='Y'&&q!='y'){}
        else
        exit(0);


    }

              }


            }while (!(x>=0&&x<=9&&y<=9&&y>=0));


        finish=checkendm(hitm,lop);


        }

        rlutil::setColor(14);
     cout<<"\n\n\n\t\tGAME OVER  !!!   ";
     cout<<"\n\n\t\t "<<finish<<"  has won the game";
     cout<<"\n\n\n";








          }//  End of Multiplayer Mode


ex:

    return 0;
}
